#!/bin/sh
spitshell=cat
package=IRC

echo "Extracting src/version.c..."

if test -r version.c.last
then
	generation=`sed -n 's/^char \*generation = \"\(.*\)\";/\1/p' < version.c.last`
if test ! "$generation" ; then generation=0; fi
else
	generation=0
fi

generation=`expr $generation + 1`

uname=`uname -a`

creation=`date | awk '{if (NF == 6) { print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } else { print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`

$spitshell >version.c <<!SUB!THIS!
/*
 *  UltimateIRCd - an Internet Relay Chat Daemon, src/version.c.SH
 *
 *  Copyright (C) 1990-2005 by the past and present ircd coders, and others.
 *  Refer to the documentation within doc/authors/ for full credits and copyrights.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  $Id: version.c.SH 921 2005-04-10 22:30:59Z shadowmaster $
 *
 */

/*
 * This file is generated by version.c.SH. Any changes made will go away.
 */

#include "struct.h"
#include "version.h"

char *generation = "$generation";
char *creation = "$creation";
char version[128];
char protoctl[512];


/*
 * No Name or entry in this list should EVER be removed other
 * than by the person who put it there.
 */

char *creditstext[] =
    {

	"\2==================== UltimateIRCd Credits ====================\2",
	"",
	"UltimateIRCd is maintained by ShadowRealm Creations.",
	"Based on, and released as a work derrived from GPL software.",
	"Please see /COPYRIGHT for more information.",
	"",
	"\2========================= The Developers =========================\2",
	"",
	"\2Active team members:\2",
	"",
	"\2ShadowMaster\2 - Thomas Juberg Stenss - <ShadowMaster@Shadow-Realm.org>",
	" - Team lead",
	"",
	"\2AgAiNaWaY\2 - Mathias Vrs - <Againaway@Shadow-Realm.org>",
	" - Programmer, bug hunter",
	"",
	"\2Phealy\2 - Patrick Healy - <Phealy@Shadow-Realm.org>",
	" - Programmer, documentation, bug hunter",
	"",
	"\2Radiant\2 - Thomas Wagenveld - <Radiant@Shadow-Realm.org>",
	" - Programmer, bug hunter, Win32 porter",
	"",
	"\2Others that have helped out:\2",
	"",
	"\2Acidic32\2 - Daniel Moss <Acidic32@Shadow-Realm.org>",
	" - Code contributor",
	"",
	"\2Belinda\2 - <Belinda@Shadow-Realm.org>",
	" - Documentation",
	"",
	"\2Dief\2 - <Dief@Shadow-Realm.org>",
	" - Code contributor",
	"",
	"\2Dooley\2 - <Dooley@Shadow-Realm.org>",
	" - Code contributor and beta testing.",
	"",
	"\2Fish\2 - Justin Hammond - <Fish@Shadow-Realm.org>",
	" - Programmer",
	"",
	"\2HMetal\2 - Ray Akey - <rakey@Amiga.com>",
	" - Code contributor",
	"",
	"\2Miles\2 - K. Hawkes - <k.hawkes@zombies.force9.net>",
	" - Code contributor",
	"",
	"\2WarNPeace\2 - John M. Hoyt - <amicon@amicon.net>",
	" - Bug reporter, beta tester and all hands person.",
	"",
	"\2=============== ShadowMaster would like to thank ===============\2",
	"",
	"\2Infomedia Inc, & Joel Comm\2",
	" - For believing in me and giving me the chance to start off this project.",
	"",
	"\2All Admins And Networks Using UltimateIRCd\2",
	" - For your support, ideas, bugreports, constructive critisism,",
	"   and for making us want to go on developing the IRCd and make it better.",
	"",
	"\2Des\2",
	" - ",
	"",
	"\2Marvie\2",
	" - For your friendship, for your love, for the endless hours you've spent with me.",
	"   For giving me the strength through tough times.",
	"",
	"\2Emerald\2",
	" - For all the things you have done for me.",
	"   For all the joy and happiness you brought into my life.",
	"   For being a bright and shining star in my life when no other light where in sight.",
	"",
	"\2DarkWolf\2",
	" - For always being there there for me, both with moral support and technical support",
	"   For being a good friend and caring for me.",
	"",
	"\2DKay\2",
	" - For endless support with both Beta Testing and for",
	"   being there when i needed it.",
	"",
	"\2Serena\2",
	" - For always being there to pick up the pieces, and putting them back together again.",
	"",
	"\2Nak\2",
	" - Without you this would not exsist.",
	"",
	"\2Zave\2",
	" - For inspiration, being a good friend, letting me be in the Zaveland Chronicles,",
	"   and everything else you have done for me.",
	"",
	"\2WarNPeace\2",
	" - For constantly bugging me about bugs, typos etc and making sure i fixed them.",
	"   Always coming up with new ideas and suggestions, and most of all supporting my work.",
	"",
	"\2HMetal\2",
	" - For all the hints and tips on coding you have given me trough the years.",
	"   Not to forget all the bugfixes and code snipits you have added to this IRCd.",
	"",
	"\2========================= Additional thanks to =========================\2",
	"",
	"Jarkko Oikarinen, The development teams of StarChat, Bahamut, DreamForge, Hybrid,",
	"IRCu, Ratbox, Rage, Unreal, Elite IRCd's and all others who continue working to improve IRC.",
	"Crash, RogerY, Binary, Nuclear-X, Snazzy, Kerrne, Derelict, Magic, Mayor, Allan,",
	"Auntie, ToyMaster, XT, ZJ, CM, JyNx, Benjamin, SaNdMaN, Rascle, CJ, DodGeR, Pierre-Luc,",
	"Quinn, Dief, Dooley, StrikerST, n3rd, ET, Anomy, Aeon, Rheem, Keindra and everyone who",
	"have added their code, advice and opinions to the development of this IRCd.",
	"",
	"\2=================================================================~\2",
	0,
    };


char *copyrighttext[] =
    {
	"\2==================== UltimateIRCd Copyrights ====================\2",
	"",
 	"UltimateIRCd is Copyright (C) 1990-2005 by the past and present ircd coders, and others.",
      	"Refer to the documentation within doc/authors/ for full credits and copyrights.",
	"The archive containing this documentation can be obtained from",
	"http://www.shadow-realm.org/",
	"",
	"This program is free software; you can redistribute it and/or modify",
	"it under the terms of the GNU General Public License as published by",
	"the Free Software Foundation; either version 2 of the License, or",
	"(at your option) any later version.",
	"",
	"This program is distributed in the hope that it will be useful,",
	"but WITHOUT ANY WARRANTY; without even the implied warranty of",
	"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the",
	"GNU General Public License for more details.",
	"",
	"A copy of the GNU General Public License are distributed alongside all",
	"official releases of UltimateIRCd. It can also be obtained by writing to",
	"Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,",
	"MA  02111-1307 USA",
	"",
	"\2============================================================\2",

	 0,
};


!SUB!THIS!
