# Snacktime fingerprint file.

# An entry should look something like this:

# OSName_Version  WinSize:13013  MaxTTL:130  3.0000 6.0000 12.0000

# The example above breaks down like so:

# OSName_Version : Name/Version of the device (version is optional)
# WinSize:13013  : Caps count! This is the default window size.
# TTL:130        : Caps count! Max TTL.
# 3.000 6.00 etc : Seconds elapsed between retries. Should be an average.

# WinSize and TTL are both optional and used if you're scoring with -m
# (morestuff) option turned on. Note, if you include one, you must
# include the other, and they must be listed in this order, immediately
# following the OS name, and before retry expectations. You also might want
# to assign zeros to these values if you only know (or trust) one value but
# not the other (for some reason).

# For more details on scoring, see the documentation at
# http://www.planb-security.net/wp/snacktime.html

# These fingerprints come from my own observations, which are sometimes less
# than scientific. If you have a correction or an addition, please send your
# own fingerprint file to snacks@planb-security.net.

# Oh, and as far as I know, portscanning is mostly legal in the U.S. However
# using snacktime.pl for nefarious purposes is your choice -- don't blame me
# if you get disappeared by the NSA for profiling their servers.

# Microsoft OSes (my favorite!)

Windows_98					WinSize:8576	MaxTTL:128	2.952644	6.0022782	11.996575
Windows_NT_4.0_Server		WinSize:8576	MaxTTL:128	2.9853798	6.562300	13.124814
Windows_2000_Server_SP2		WinSize:16616	MaxTTL:128	3.239946	6.5622495
Windows_2000_Server_SP3		WinSize:64240	MaxTTL:128	3.24279255	6.5629742
Windows_XP_Professional		WinSize:64240	MaxTTL:128	2.9174267	6.00836995
Windows_DotNet_RC3718		WinSize:16616	MaxTTL:128	2.838654	6.036217


# Other OSes I've verified by logging in and checking. Most of this comes from
# HP's most excellent Test Drive collection. Note on Tru64 -- it sends a reset
# about 45 seconds after the last syn-ack. Be nice to capture this event and
# score on it.

FreeBSD_4.6-4.7			WinSize:65535	MaxTTL:64	2.998000	5.998759	11.998797
SunOS_5.5.1			WinSize:9112	MaxTTL:255	3.294753	6.549575	13.133379	26.255937	52.499543	56.261045
OpenBSD_3.1			WinSize:16384	MaxTTL:64	5.995441	12.004681	23.997086
HP_Tru64_Unix_4.0		WinSize:32768	MaxTTL:64	6.12239		24.501044
HP_Tru64_Unix_5.1		WinSize:61440	MaxTTL:64	5.828581	23.909469
HP_OpenVMS_7.3-1		WinSize:3000	MaxTTL:64	5.329235	23.543524
HP-UX_11i_11.x			WinSize:32768	MaxTTL:64	2.045152	3.073131	6.123017	12.218493	24.40294
Linux_2.4.18			WinSize:5840	MaxTTL:64	3.87539		6.001867	11.997174	24.201297	48.198805
Linux_2.4.18_Alpha		WinSize:5840	MaxTTL:64	3.996112	7.568713	13.546535	25.499794	48.004511
Linux_2.4.9			WinSize:5840	MaxTTL:64	3.399331	6.181836	13.352204	24.119482	48.040357
Linux_2.4.9_Alpha		WinSize:5840	MaxTTL:64	3.398249	7.571479	13.549039	25.508539	48.023238
OpenBSD_3.2			WinSize:17520	MaxTTL:64	5.995441	12.004681	23.997086
# That's kinda weird -- OpenBSD 3.2's first snack has a winsize of 16384, then jumps to 17520.

# Network router devices.

Linksys_Cable_Router_BEFSR41	WinSize:5840	MaxTTL:150	1.300000	1.999850	3.999934

# Printers and other silly devices

Lexmark_Optra_S			WinSize:1010	MaxTTL:255	0.503486	1.004822	2.010149	4.020346	8.040557	16.081185	20.101495	20.101539	20.101505	20.101432	20.101572	20.101470
HP_JetDirect			WinSize:8192	MaxTTL:64	5.78135		24.000062

# Interesting. Dell DRAC's TTL counters are all wacky -- TCP TTLs are way 
# different from their ICMP TTLs, and furthermore, send a very HPish 
# reset after two retries. Also saw their IPID's are sequential, and start
# from zero.
 
Dell_DRAC_2	WinSize:4096	MaxTTL:64	5.548309	23.995975


# Generic entries for more general hits. Feel free to comment these out. (Generic OSes are good catchalls if nothing else fits)

Generic_Perfect_RFC_2988_Stack	WinSize:0	MaxTTL:0	3.000000	6.000000	12.00000	24.00000	48.00000	96.0000
Generic_Post-NT_Microsoft_Stack	WinSize:0	MaxTTL:0	3.000000	6.000000
Generic_BSD_Stack		WinSize:0	MaxTTL:0	3.000000	6.000000	12.00000





